
package rss;

import java.util.*;



/***********************************************************
 ***********************************************************/
public class Rsst4j{

static {
	System.loadLibrary("rsst4j");
};


/* Return Values */
	public static final int RSS_RT_SUCCESS=		0;
	public static final int RSS_RT_FATAL=		-1;
	public static final int RSS_RT_RSS_TOO_LONG=	-100;
	public static final int RSS_RT_RSS_NULL=	-101;
	public static final int RSS_RT_RSS_INVALID=	-102;
	public static final int RSS_RT_KEY_TOO_LONG=	-200;
	public static final int RSS_RT_KEY_EMPTY=	-201;
	public static final int RSS_RT_KEY_BAD_CHAR=	-202;
	public static final int RSS_RT_VALUE_NOSPACE=	-300;
	public static final int RSS_RT_VALUE_TOO_LONG=	-301;
	public static final int RSS_RT_VALUE_NULL=	-302;
	public static final int RSS_RT_VALUE_INVALID=	-303;
	public static final int RSS_RT_RSSI_ERROR=	-400;
	public static final int RSS_RT_FILE_ERROR=	-500;

	public static final int RSS_RT_UNKNOWN_ACTION=		1000;
	public static final int RSS_RT_BAD_HANDLE_STATUS=	1001;
	public static final int RSS_RT_INVALID_PROP=		1002;
	public static final int RSS_RT_INVALID_VALUE=		1003;


/* Options */
	public static final int RSS_OP_KEY_FAMILY_GET=	1;
	public static final int RSS_OP_KEY_MULTI_LEVEL=	2;


/* Status Values */
	public static final int RSS_STATUS_NONE=	0;
	public static final int RSS_STATUS_START=	1;


/* inside */
	public Hashtable InsideObjs = new Hashtable();

	private int MyRsst;
	private boolean IsMine;


	private native void CreateRsst4j();
	private native void DestroyRsst4j();


/*
 */
public int getRsst(){
	return MyRsst;
}


/*
 */
public Rsst4j(){
	CreateRsst4j();
	IsMine=true;
}


/*
 */
public Rsst4j(int rsst){
	MyRsst=rsst;
	IsMine=false;
}


/*
 */
protected void finalize() throws Throwable{
	if(IsMine)
	DestroyRsst4j();
	super.finalize();
}


	public native int RssValid(byte[] rss);
	public native int RssValidKey(byte[] key);
/*
 */
public int RssValidKey(String key){
	return RssValidKey( key.getBytes() );
}


	public native int Check();


	public native byte[] getRss();
	public native void setRss(byte[] rss);
	public native void Clear();

	public native void RssLoad(byte[] filename);
/*
 */
public void RssLoad(String filename){
	RssLoad( filename.getBytes() );
}


	public native void RssDump(byte[] filename);
/*
 */
public void RssDump(String filename){
	RssDump( filename.getBytes() );
}


	public native int  getLen();
	public native int  getMaxLen();
	public native void setMaxLen(int max_len);
	public native int  getMaxValueLen();
	public native void setMaxValueLen(int max_len);
	public native int  getUnitSize();
	public native void setUnitSize(int unit_size);
	public native int  getOption(int opt);
	public native void setOption(int opt, int f);

	public native int  getRtCode();
	public native void setRtCode(int rtcode);
	public native int  getStatus();
	public native void setStatus(int status);

	public native int  getHandle();
	public native void setHandle(int handle);
	public native int  newHandle();
	public native void closeHandle();


	public native byte[] KeyGet(byte[] key);
/*
 */
public byte[] KeyGet(String key){
	return KeyGet( key.getBytes() );
}


	public native byte[] KeyGetM(byte[] key, int no);
/*
 */
public byte[] KeyGetM(String key, int no){
	return KeyGetM( key.getBytes(), no );
}


	public native void KeyPut(byte[] key, byte[] value);
/*
 */
public void KeyPut(String key, byte[] value){
	KeyPut( key.getBytes(), value );
}
/*
 */
public void KeyPut(String key, String value){
	KeyPut( key.getBytes(), value.getBytes() );
}


	public native void KeyPutM(byte[] key, byte[] value, int no);
/*
 */
public void KeyPutM(String key, byte[] value, int no){
	KeyPutM( key.getBytes(), value, no );
}
/*
 */
public void KeyPutM(String key, String value, int no){
	KeyPutM( key.getBytes(), value.getBytes(), no );
}


	public native int KeyGetInteger(byte[] key);
/*
 */
public int KeyGetInteger(String key){
	return KeyGetInteger( key.getBytes() );
}

	
	public native int KeyGetMInteger(byte[] key, int no);
/*
 */
public int KeyGetMInteger(String key, int no){
	return  KeyGetMInteger( key.getBytes(), no );
}


	public native void KeyPutInteger(byte[] key, int value);
/*
 */
public void KeyPutInteger(String key, int value){
	KeyPutInteger( key.getBytes(), value );
}


	public native void KeyPutMInteger(byte[] key, int value, int no);
/*
 */
public void KeyPutMInteger(String key, int value, int no){
	KeyPutMInteger( key.getBytes(), value, no );
}


	public static native void KeyCopy(int rsst1, int rsst2, byte[] key);
/*
 */
public static void KeyCopy(Rsst4j rsst1, Rsst4j rsst2, String key){
	KeyCopy( rsst1.MyRsst, rsst2.MyRsst, key.getBytes() );
}


	public static native void KeyCopyFamily(int rsst1, int rsst2, byte[] key0);
/*
 */
public static void KeyCopyFamily(Rsst4j rsst1, Rsst4j rsst2, String key0){
	KeyCopyFamily( rsst1.MyRsst, rsst2.MyRsst, key0.getBytes() );
}


	public native void KeyList();
	public native void KeyListFamily(byte[] key0);
/*
 */
public void KeyListFamily(String key0){
	KeyListFamily( key0.getBytes() );
}


	public native void ArrayFetch(byte[] key);
/*
 */
public void ArrayFetch(String key){
	ArrayFetch( key.getBytes() );
}


	public native void ArrayNew();
	public native void ArraySave(byte[] key);
/*
 */
public void ArraySave(String key){
	ArraySave( key.getBytes() );
}


	public native byte[] ArrayGet(int no);
	public native void ArrayPut(byte[] value, int no);
/*
 */
public void ArrayPut(String value, int no){
	ArrayPut( value.getBytes(), no );
}


	public native int ArrayGetInteger(int no);
	public native void ArrayPutInteger(int value, int no);

	public native int ArrayItemNum();
	public native void ArrayRemoveItem(int no);


	public native void TableCreate(byte[] tbl_name);
/*
 */
public void TableCreate(String tbl_name){
	TableCreate( tbl_name.getBytes() );
}


	public native void TableSave(int col_num, int row_num, int start_row);
	public native void TableOpen(byte[] tbl_name);
/*
 */
public void TableOpen(String tbl_name){
	TableOpen( tbl_name.getBytes() );
}


	public native int TableGetColNum();
	public native int TableGetRowNum();
	public native int TableGetStartRow();

	public native void TableFetchRow(int row);
	public native void TableNewRow();
	public native void TableSaveRow(int row);


	public native byte[] TableGet(int col);
	public native void TablePut(byte[] value, int col);
/*
 */
public void TablePut(String value, int col){
	TablePut( value.getBytes(), col );
}


	public native int TableGetInteger(int col);
	public native void TablePutInteger(int value, int col);


	public native int Locate(byte[] DllPath, byte[] FuncName);
/*
 */
public int Locate(String DllPath, String FuncName){
	return Locate( DllPath.getBytes(), FuncName.getBytes() );
}


	public native void CallRssi(byte[] Action);
/*
 */
public void CallRssi(String Action){
	CallRssi( Action.getBytes() );
}

}
