/*
 * Simple Command Shell RSSI 
 *
 * Author: Liu Rui
 * 
 * RSS (Regular Statement String) is a development tool for software
 * application venders or developers to build their friendly user interfaces or
 * represent their informations.
 *  
 * You may use this software freely and may ask for help from Liu Rui as you 
 * meet any technical problems about it. But Liu Rui does not guarantee your 
 * applications to be well done.
 */

/******************************************************************************/
/*---------------------------- HEADER FILES ----------------------------------*/
#include "cmdshell.h"


/******************************************************************************/
/*-------------------------------- FUNCTIONS ---------------------------------*/


/*
 */
static int ParseCmd1( char **cmd, Rsst *rsst, int n ){
	char *p, *q;
	int ex=0;

for( p=*cmd; *p && *p!='\n' && *p!='\r'; p++ ){
	if( *p==' ' || *p=='\t' ) continue;

 if( *p=='\"' ){
	q= strchr( ++p, '\"' );
	if(!q) return 1;
 }
 else{
	for( q=p; *q && *q!='\n' && *q!='\r' && *q!=' ' && *q!='\t'; q++ )
	;
 }
 
	if( *q== '\0' )
	ex=1;
	
	*q= '\0';
	RsstArrayPut0(rsst, p, n);

	if(!ex)
	*cmd=q;
	else
	*cmd=0;
	
	return 0;
}

	*cmd=0;
	return 0;
}


/*
 */
static int ParseCmd(char *buf, Rsst *rsst){
	int i, rt;
	char *p;

	RsstArrayNew(rsst);
	
for( p=buf, i=1; *p && *p!='\n' && *p!='\r'; p++, i++ ){
	if( rt= ParseCmd1( &p, rsst, i ) ) return rt;
	if(!p) break;
}

	RsstArraySave( rsst, "Command" );
	return 0;
}


/*
 */
static int IfCmdInList(char *cmd, char *list){
	char *p, c;
	
	p= strstr(list, cmd);
	if(!p) return 0;
	
	c= *( p+ strlen(cmd) );
	if( c!='\0' && c!=',' ) return 0;

	if( p==list || *(p-1)==',' ) return 1;
	
	return 0;
}


/*
 */
RSSI_DLL_EXPORT void CmdShellRssi(Rsst *rsst, char *act){
	int rt, status;
	char prompt[32], buf[4096], cmd[128], *p;
	Rsst *h_rsst;


if( !strcmp( act, "Activate" ) ){
	h_rsst= RsstNewHandle(rsst);

	p= RsstKeyGet0( rsst, "Prompt" );
	if(!*p)
	p=DEFAULT_PROMPT;
	RsstKeyPut0( h_rsst, "Prompt", p );
	RsstKeyCopy( rsst, h_rsst, "HelpCommand" );
	RsstKeyCopy( rsst, h_rsst, "HelpString" );
	RsstKeyCopy( rsst, h_rsst, "ExitCommand" );

	puts( RsstKeyGet0( rsst, "Title" ) );
	
	RsstClear(rsst);
	RsstSetStatus( rsst, RSS_STATUS_START );
}
else if( !strcmp( act, "Deactivate" ) ){
	RsstCloseHandle(rsst);
}
else if( !strcmp( act, "WaitCommand" ) ){
	h_rsst= RsstGetHandle(rsst);
	status= RsstGetStatus(rsst);
 if(!h_rsst || !status){
 	RsstSetRtCode(rsst, RSS_RT_BAD_HANDLE_STATUS);
 	return;
 }

	p= RsstKeyGet0( rsst, "Prompt" );
	if(!*p)
	p= RsstKeyGet0( h_rsst, "Prompt" );
	StringFitIn( prompt, p, sizeof(prompt) );

	*buf = '\0';
 while(!*buf){
	//fputs(prompt, stdout);
	printf(prompt);
	gets(buf);
 }
	RsstKeyPut0(rsst, "CommandLine", buf);

 if( ParseCmd(buf, rsst) ){
	RsstSetRtCode(rsst, RSS_RT_INVALID_COMMAND);
	return;
 }
   	StringFitIn( cmd, RsstKeyGet0( rsst, "Command" ), sizeof(cmd) );
   	
 if( IfCmdInList( cmd, RsstKeyGet0( h_rsst, "HelpCommand" ) ) ){
	puts( RsstKeyGet0( h_rsst, "HelpString" ) );
 	RsstSetRtCode(rsst, RSS_RT_WANT_HELP);
 }
 else if( IfCmdInList( cmd, RsstKeyGet0( h_rsst, "ExitCommand" ) ) ){
 	RsstSetRtCode(rsst, RSS_RT_WANT_QUIT);
 }
 else if( !strcmp( cmd, "prompt" ) ){
	RsstKeyPut0( h_rsst, "Prompt", RsstKeyGetM0(rsst, "Command", 2) );
	RsstSetRtCode(rsst, RSS_RT_CHANGE_PROMPT);
 }
}
else if( !strcmp( act, "Print" ) ){
	//fputs( RsstKeyGet0( rsst, "String" ), stdout );
	printf( RsstKeyGet0( rsst, "String" ) );
}
else if( !strcmp( act, "ParseCommand" ) ){
	rt= ParseCmd( RsstKeyGet0( rsst, "CommandLine" ), rsst );

	if( rt!=0 )
	RsstSetRtCode( rsst, RSS_RT_INVALID_COMMAND );
}
else{
	RsstSetRtCode( rsst, RSS_RT_UNKNOWN_ACTION );
}

}
