/*
 * Registry RSSI 
 *
 * Author: Liu Rui
 * 
 * RSS (Regular Statement String) is a development tool for software application
 * venders or developers to build their friendly user interfaces or represent
 * their informations.
 *  
 * You may use this software freely and may ask for help from Liu Rui as you 
 * meet any technical problems about it. But Liu Rui does not guarantee your 
 * applications to be well done.
 *
 */


/******************************************************************************/
/*---------------------------- HEADER FILES ----------------------------------*/
#include <conio.h>
#include "../../include/rss.h"


/******************************************************************************/
/*---------------------------- Global Variables ------------------------------*/
Rsst Rsst1;


/******************************************************************************/
/*-------------------------------- FUNCTIONS ---------------------------------*/


/*
 */
int CheckResult(){
	int rt;
	
	rt= RsstGetRtCode(&Rsst1);
if(rt<0){
	printf( "Error, code=%d\n", rt );
	exit(rt);
}

	return rt;
}


/*
 */
int main(){
	int ch;
	
/* Init */
	puts("Init");

	RsstInit( &Rsst1, 0 );
if( Locate( &Rsst1, "Rss4Vb", "Rss4VBRssi" ) ){
	puts("Can not locate RSS DLL");
	exit(-1);
}

	RsstClear( &Rsst1 );
	RsstKeyPut0( &Rsst1, "PrgID", "Waiter.Serve" );
	RsstKeyPut0( &Rsst1, "EntryName", "VBRssi" );
	Rsst1.Rssi( &Rsst1, "Activate" );
	CheckResult();

/* Call VB */
	puts("Options:");
	puts("0 - Quit");
	puts("1 - Send Email");
	puts("2 - Word");
	puts("3 - Excel");

do{
	ch= _getch();

 switch(ch){
 case '0':
 	puts("Quit...");

	break;
 case '1':
 	puts("Send Email...");

	RsstClear( &Rsst1 );
	RsstKeyPut0( &Rsst1, "ToAddr", "liurui@lrsolution.com" );
	Rsst1.Rssi( &Rsst1, "SendEMail" );
	CheckResult();
;
	printf( "Return code=%d\n", RsstGetRtCode(&Rsst1) );

	break;
 case '2':
 	puts("Use Word...");

	RsstClear( &Rsst1 );
	RsstKeyPut0( &Rsst1, "Text", "Rss is very easy to use." );
	Rsst1.Rssi( &Rsst1, "UseWord" );
	CheckResult();

	break;
 case '3':
 	puts("Use Excel...");

	RsstClear( &Rsst1 );
	RsstKeyPut0( &Rsst1, "Text", "Database" );
	Rsst1.Rssi( &Rsst1, "UseExcel" );
	CheckResult();

	break;
 default:
 	puts("Unknow input");
 }
}while(ch!='0');

/* End */
	RsstClear( &Rsst1 );
	Rsst1.Rssi( &Rsst1, "Deactivate" );
	CheckResult();
	RsstClose(&Rsst1);
	return 0;
}
