
import java.util.*;
import rss.*;

import xmlerj.*;


/***********************************************************
 ***********************************************************/
public class Test{

	static Rsst4j Rsst1= new Rsst4j();


/*
 */
static public void CheckResult(){
	int rt= Rsst1.getRtCode();
 if( rt!=0 ){
	System.out.println( "RtCode=" + rt );
	System.exit(-1);
 }
}


/*
 */
static public void Parse(Xmler x, String path) throws java.io.IOException{
	String type, s;
	int i, n;

	System.out.println( "Parse Path: " + path );
 	Rsst1.Clear();
 	Rsst1.KeyPut( "Path", path );
 	x.Rssi( Rsst1, "Locate" );
	CheckResult();

	s= new String(Rsst1.KeyGet("Type"));
	if( s.equals("N") )
	type= "Element";
	else if( s.equals("A") )
	type= "Attribute";
	else
	type= "Unknow";

	System.out.println( "Node Type = " + type );
	System.out.println( "Node Value = " + new String(Rsst1.KeyGet("Value")).trim() );

 if( type.equals("Element") ){
	Rsst1.ArrayFetch("SubNodes");
	n= Rsst1.ArrayItemNum();
	s= "SubNodes = ";
	for(i=1; i<=n; i++)
	s+= new String(Rsst1.ArrayGet(i)) + ", ";
	System.out.println(s);

	Rsst1.ArrayFetch("Attribues");
	n= Rsst1.ArrayItemNum();
	s= "Attribues = ";
	for(i=1; i<=n; i++)
	s+= new String(Rsst1.ArrayGet(i)) + ", ";
	System.out.println(s);
 }

	System.out.println("");
}


/*
 */
static public void main( String astrArg[] ){
	String xmlFile;

 try{	
	if( astrArg.length ==0 )
	xmlFile="gjobs.xml";
	else
	xmlFile=astrArg[0];
	System.out.println( "--------Begin---------" );
	System.out.println( "Parse XML File: " + xmlFile );
	
	Xmler x= new Xmler();

 	Rsst1.Clear();
 	Rsst1.KeyPut( "XMLFileName", xmlFile );
 	x.Rssi( Rsst1, "Activate" );
	CheckResult();
	System.out.println( "XML Version = " + new String(Rsst1.KeyGet("Version")) );
	System.out.println( "Root Node Name = " + new String(Rsst1.KeyGet("Root")) + "\n" );

	Parse(x, "/Helping/Jobs/Job/Application");
	Parse(x, "/Helping/Jobs/Job/Project<name");
	Parse(x, "/Helping/Jobs/Job");
	Parse(x, "/Helping/Jobs/Job/Developers/>2");

	System.out.println( "--------End---------" );
 	Rsst1.Clear();
	Rsst1.KeyPut( "Action", "Deactivate" );
	CheckResult();
 }
 catch(java.io.IOException ex){
	System.out.println( ex.getMessage() );
	ex.printStackTrace();
 }

}

}
