/* This is the java implementation of XMLer v0.1 based on xerces.
 */

package xmlerj;

import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.*;
import org.xml.sax.SAXException;
import java.io.*;

import rss.*;


/******************************************************************************/
public class Xmler implements Rsso{

	public static final int RSS_RT_ERROR_OPEN_XMLDOC=	10000;
	public static final int RSS_RT_INVALID_PATH=		10001;
	public static final int RSS_RT_IO_ERROR=		10002;


/*
 */
String getElementName(String path, int i){
	int n;
	
	n= path.indexOf('/', i);
	if(n<0) return path.substring(i);
	
	return path.substring(i,n);
}


/*
 */
Node Locate(Node d, String ename){
	int i, j, n, m;
	String s;
	NodeList nl;
	Node nd;
	
	nl= d.getChildNodes();
	n= nl.getLength();

 if( ename.charAt(0) !='>' ){
  for(i=0; i<n; i++){
	nd= nl.item(i);
	if( nd.getNodeName().equals(ename) )
	return nd;
  }
 }
 else{
	s= ename.substring(1);
	m= Integer.parseInt(s);

  for(i=0, j=0; i<n; i++){
	nd= nl.item(i);
	if( nd.getNodeType() == Node.ELEMENT_NODE )
	j++;

	if(j==m)
	return nd;
  }
 }

	return null;
}


/*
 */
void SetNodeValues(Rsst4j rsst, Node d){
	int i, n;
	String s;
	NodeList nl;
	Node nd;
	NamedNodeMap nm;
	
	nl= d.getChildNodes();
	n= nl.getLength();
	if(n<=0) return;

   	//nd= d.getFirstChild();
	nd= nl.item(0);
	s= nd.getNodeValue();
	if( s!=null && nd.getNodeType()== Node.TEXT_NODE  )
	rsst.KeyPut( "Value", s );

	rsst.ArrayNew();
 for(i=0; i<n; i++){
	rsst.ArrayPut( nl.item(i).getNodeName().getBytes(), i+1 );
 }
	rsst.ArraySave("SubNodes");

	nm= d.getAttributes();
	n= nm.getLength();
	rsst.ArrayNew();
 for(i=0; i<n; i++){
	d= nm.item(i);
	rsst.ArrayPut( nm.item(i).getNodeName().getBytes(), i+1 );
 }
	rsst.ArraySave("Attribues");
}



/*
 */
public void Rssi(int rsst, byte[] Action){
	Rssi( new Rsst4j(rsst), new String(Action) );
}


/*
 */
public void Rssi(Rsst4j rsst, String action){
	Rsst4j rsst_hd;
	String path, type, attr, ename, s;
	int n, i, path_len, path_len_1;
	Document document;
	Node d;
	NamedNodeMap nm;

 try{
  if( action.equals("Activate") ){
	rsst_hd= new Rsst4j( rsst.newHandle() );

   try{
	DOMParser parser= new DOMParser();
	parser.parse( new String( rsst.KeyGet("XMLFileName") ) );
	document= parser.getDocument();
 	rsst.InsideObjs.put( "Doc", document );
   }
   catch (org.xml.sax.SAXException ex) {
	rsst.setRtCode(RSS_RT_ERROR_OPEN_XMLDOC);
	return;
   }

	rsst.Clear();
	rsst.KeyPut( "Version", document.getVersion() );
	rsst.KeyPut( "Root", document.getDocumentElement().getNodeName() );
	rsst.setStatus( Rsst4j.RSS_STATUS_START );
  }
  else if( action.equals("Deactivate") ){
	rsst.closeHandle();
  }
  else if( action.equals("Locate") ){
   if( rsst.getStatus()==0 || rsst.getHandle()==0 ){
 	rsst.setRtCode(Rsst4j.RSS_RT_BAD_HANDLE_STATUS);
 	return;
   }
 	//rsst_hd= new Rsst4j( rsst.getHandle() );

	document= (org.w3c.dom.Document)rsst.InsideObjs.get("Doc");
   if(document==null){
	rsst.setRtCode(RSS_RT_ERROR_OPEN_XMLDOC);
	return;
   }

	path= new String( rsst.KeyGet("Path") );
	rsst.Clear();
	n= path.indexOf('<');
   if(n<0){
	attr="";
	type= "N";
	rsst.KeyPut( "Type", type );
   }
   else{
	attr= path.substring(n+1);
  	path= path.substring(0,n);
	type= "A";
	rsst.KeyPut( "Type", type );
   }

   if( (path.length()<2) || (path.charAt(0) !='/') ){
	rsst.setRtCode(RSS_RT_INVALID_PATH);
	return;
   }

	d= document.getDocumentElement();
	path_len= path.length();
	path_len_1=path_len-1;
   for( i=1; i<path_len_1; i++ ){
	if( path.charAt(i) != '/' ) continue;
	ename= getElementName(path, ++i);
	d= Locate(d, ename);
    if(d==null){
	rsst.setRtCode(RSS_RT_INVALID_PATH);
   	return;
    }
   }

   if( type.equals("N") ){
  	SetNodeValues(rsst, d);
   }
   else if( type.equals("A") ){
	nm= d.getAttributes();
	n= nm.getLength();

    for(i=0; i<n; i++){
	d= nm.item(i);
     if( d.getNodeName().equals(attr) && d.getNodeType()== Node.ATTRIBUTE_NODE ){
	s= d.getNodeValue();
	if( s!=null )
	rsst.KeyPut( "Value", s );
     }
    }
   }
  }
  else{
	rsst.setRtCode(Rsst4j.RSS_RT_UNKNOWN_ACTION);
  }
 }
 catch(java.io.IOException ex){
	rsst.setRtCode(RSS_RT_IO_ERROR);
 }
}

}
